#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from tkinter import *
import tkinter
import socket
import os
import subprocess
import threading
import raspi_openjtalk as jt

HOST = 'localhost'
PORT1 = 60002
PORT2 = 60003
MAX_BUFFER = 2048
NUM_THREAD = 4

my_pid = os.getpid()

def quit():
    subprocess.call("./stop_me.sh")
    '''
    root.quit()
    root.destroy()
    os._exit(0)
    '''

def message_send():
    temp = text.get()
    send_message(temp)

def send_message(mes):
    while True:
        try:
            # 通信の確立
            s_sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s_sock.connect((HOST, PORT1))
            
            # メッセージ送信
            s_sock.send(mes.encode('utf-8'))
            # 通信の終了
            s_sock.close()
            break
            
        except:
            print ('error: ' + mess)
            break

def request_receive():
    r_sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    r_sock.bind ((HOST, PORT2))
    r_sock.listen (NUM_THREAD)
    print ('receiver ready, NUM_THREAD = ' + str(NUM_THREAD))
    
    while True:
        try:
            conn,addr = r_sock.accept()
            mess = conn.recv(MAX_BUFFER).decode('utf-8')
            conn.close()
            #print('RECEIVED MESSAGE:' + mess)
            mess = mess.replace("\n","。")
            jt.jtalk(mess)
        
        except:
            print('Receive Error')
    
    r_sock.close()

#
def request_receive_start():
    #別スレッドで待ち受け
    th=threading.Thread(target=request_receive)
    th.start()

root = tkinter.Tk()
root.title(u"Google Assistant")
root.geometry("400x100")
root.resizable(0,0)
root.protocol('WM_DELETE_WINDOW', quit)
root.attributes("-topmost", True)
bln = tkinter.BooleanVar()

# Frame
frame1 = tkinter.Frame(root)
frame1.rowconfigure(1, weight=1)
frame1.columnconfigure(0, weight=1)
frame1.grid(sticky=(N,W,S,E))


#Button
button1 = tkinter.Button(frame1, text='テキスト入力', command=message_send)
button1.grid(row=0, column=0, columnspan=2, sticky=(N,W))

text = tkinter.Entry(frame1, width=55)
text.grid(row=1, column=0, columnspan=2, sticky=(NW,SE))


request_receive_start()
root.mainloop()


